//+------------------------------------------------------------------+
//|                                                 Data_for_NS2.mq4 |
//|                                                      StatBars TO |
//|                                             Tradexperts@inbox.ru |
//+------------------------------------------------------------------+
#property copyright "StatBars TO"
#property link      "Tradexperts@inbox.ru"
#property show_inputs
#define DIM          7     //  (+)
#define NUM_PATTERNS 3000  // ,  ...

extern datetime   Start_Date=D'2009.01.01 00:00';  //  .           !
extern string     filename="File_for_NN";          //    
extern int        _=0;              // 0 -  , 1 - 
extern double     _=2;     //  
extern double     _=1;       //     
extern bool       _=true;    // 
extern double     MAX=1;                           //       
extern double     MIN=-1;                          //       
extern bool       _=true;       //  
extern double     MAX_OUTPUT=0.4;
extern double     MIN_OUTPUT=-0.4;

double data[NUM_PATTERNS][DIM];

int start()
  {
   ////////////////////////////////////////////////////////////
   ///////     ////////////////////
   // data[count-i][0]= _1
   // data[count-i][1]= _2
   // data[count-i][2]= _3
   // data[count-i][3]= _4
   // data[count-i][4]= _5
   // data[count-i][5]= _6
   //
   // data[count-i][6]= 
   //      :
   // (__( 55  )-__)/(__( 55  )-__( 55  ))
   // ..          55  ,        
   // ,     ,        0.
   //           ,       ...
   
   int count=iBarShift(Symbol(),Period(),Start_Date);
   int i,i1;
   double array[NUM_PATTERNS];
   ArrayInitialize(array,0.0);
   for(i=count+NUM_PATTERNS-1;i>=count;i--)
   {
      data[i-count][0]=iMA(Symbol(),Period(),55,0,MODE_SMMA,PRICE_MEDIAN,i+1)/iMA(Symbol(),Period(),144,0,MODE_SMMA,PRICE_MEDIAN,i+1);
      data[i-count][1]=iADX(Symbol(),Period(),24,PRICE_MEDIAN,MODE_MAIN,i+1);
      data[i-count][2]=iRVI(Symbol(),Period(),12,MODE_MAIN,i+1);
      data[i-count][3]=iDeMarker(Symbol(),Period(),34,i+1);
      data[i-count][4]=iATR(Symbol(),Period(),55,i+1);
      data[i-count][5]=Low[iLowest(Symbol(),Period(),MODE_LOW,144,i+2)]/Low[i+1];
      data[i-count][6]=(Open[iHighest(Symbol(),Period(),MODE_OPEN,55,i-56)]-Open[i])/(Open[iHighest(Symbol(),Period(),MODE_OPEN,55,i-56)]-Open[iLowest(Symbol(),Period(),MODE_OPEN,55,i-56)]);
   }
   /////////////////////////////
   ///// ////
   for(i=0;i<DIM-1;i++)//   
   {
      for(i1=0;i1<NUM_PATTERNS;i1++)
         array[i1]=data[i1][i];
      
      if(_ <= 0)
      {
         fNormalization(array,_);
      }
      if(_ > 0)
      {
         fNormalization_NonLinear(array,_,_);
      }
      if(_)
      {
         fAutoScale(array,MIN,MAX);
      }
      
      for(i1=0;i1<NUM_PATTERNS;i1++)
         data[i1][i]=array[i1];
   }
   
   ///////////////////////////////////////
   /////  /////
   for(i1=0;i1<NUM_PATTERNS;i1++)
         array[i1]=data[i1][DIM-1];
   if(_)
   {
      if(_ <= 0)
      {
         fNormalization(array,_);
      }
      if(_ > 0)
      {
         fNormalization_NonLinear(array,_,_);
      }
   }
   fAutoScale(array,MIN_OUTPUT,MAX_OUTPUT);
   for(i1=0;i1<NUM_PATTERNS;i1++)
      data[i1][i]=array[i1];
   ////// //////
   ///////////////////////////////////
   //////  ////////////////
   int Handle=FileOpen(Symbol()+"_"+Period()+"_"+filename+".csv", FILE_CSV|FILE_WRITE);
   string comm="";
   for(i=0;i<NUM_PATTERNS;i++)
   {
      comm="";
      for(i1=0;i1<DIM;i1++)
         comm=comm+DoubleToStr(data[i][i1],8)+" ";
      
      FileWrite(Handle,comm);
   }
   FileClose(Handle);
   
   return(0);
  }

void fNormalization(double&array[], double coef=2)
{//     (-)/
   int i;
   double aver=fAver(array);
   double sigma=fSigma(array);
   
   for(i=0;i<ArrayRange(array,0);i++)
   {
      array[i]=(array[i]-aver)/(coef*sigma);
      if(array[i]>coef)array[i]=coef;
      if(array[i]<-coef)array[i]=-coef;
   }
}

double fAver(double array[])//
{
   double i=ArrayRange(array,0)-1;
   double Aver=0;
   for(int count=0;count<i;count++)
         Aver+=array[count];

   Aver/=i;
   return(Aver);
}

double fSigma(double array[])// 
{
   double i=ArrayRange(array,0)-1;
   double sigma=0;
   double Aver=fAver(array);
   
   for(int count=0;count<i;count++)
      sigma+=MathPow(array[count]-Aver,2);
   
   sigma/=(i-1);
   return(MathSqrt(sigma));
}

void fNormalization_NonLinear(double&array[], double coef=2, double alpha=1)
{//    ( (-)/)
   int i;
   double aver=fAver(array);
   double sigma=fSigma(array);
   for(i=0;i<ArrayRange(array,0);i++)
   {
      if((array[i]-aver)/sigma>=coef)array[i]=coef;
      if((array[i]-aver)/sigma<=-coef)array[i]=-coef;
      if((array[i]-aver)/sigma>-coef && (array[i]-aver)/sigma<coef)array[i]=(array[i]-aver)/sigma;
      array[i]=Sigmoida(array[i],alpha);
   }
}

double Sigmoida(double x=0, double alpha=1) 
{    
	double rez=-0.5+1/(1+MathExp(-alpha*x)); 
	return(rez); 
}

void fAutoScale(double&array[], double a=0/*  */, double b=1/*  */)
{//       [;b]
   int i,i1;
   i=ArrayRange(array,0)-1;
   double x_max=array[ArrayMaximum(array,WHOLE_ARRAY,0)];
   double x_min=array[ArrayMinimum(array,WHOLE_ARRAY,0)];
   for(i=0;i<ArrayRange(array,0);i++)
   {
      array[i]=(((array[i]-x_min)*MathAbs(a-b))/(x_max-x_min))+MathMin(a,b);
   }
}